<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>TestNTLMEngineImpl xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../testapidocs/org/apache/http/impl/auth/TestNTLMEngineImpl.html">View Javadoc</a></div><pre>

<a class="jxr_linenumber" name="1" href="#1">1</a>   <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="2" href="#2">2</a>   <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="3" href="#3">3</a>   <em class="jxr_comment"> * Licensed to the Apache Software Foundation (ASF) under one</em>
<a class="jxr_linenumber" name="4" href="#4">4</a>   <em class="jxr_comment"> * or more contributor license agreements.  See the NOTICE file</em>
<a class="jxr_linenumber" name="5" href="#5">5</a>   <em class="jxr_comment"> * distributed with this work for additional information</em>
<a class="jxr_linenumber" name="6" href="#6">6</a>   <em class="jxr_comment"> * regarding copyright ownership.  The ASF licenses this file</em>
<a class="jxr_linenumber" name="7" href="#7">7</a>   <em class="jxr_comment"> * to you under the Apache License, Version 2.0 (the</em>
<a class="jxr_linenumber" name="8" href="#8">8</a>   <em class="jxr_comment"> * "License"); you may not use this file except in compliance</em>
<a class="jxr_linenumber" name="9" href="#9">9</a>   <em class="jxr_comment"> * with the License.  You may obtain a copy of the License at</em>
<a class="jxr_linenumber" name="10" href="#10">10</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="11" href="#11">11</a>  <em class="jxr_comment"> *   <a href="http://www.apache.org/licenses/LICENSE-2.0" target="alexandria_uri">http://www.apache.org/licenses/LICENSE-2.0</a></em>
<a class="jxr_linenumber" name="12" href="#12">12</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="13" href="#13">13</a>  <em class="jxr_comment"> * Unless required by applicable law or agreed to in writing,</em>
<a class="jxr_linenumber" name="14" href="#14">14</a>  <em class="jxr_comment"> * software distributed under the License is distributed on an</em>
<a class="jxr_linenumber" name="15" href="#15">15</a>  <em class="jxr_comment"> * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY</em>
<a class="jxr_linenumber" name="16" href="#16">16</a>  <em class="jxr_comment"> * KIND, either express or implied.  See the License for the</em>
<a class="jxr_linenumber" name="17" href="#17">17</a>  <em class="jxr_comment"> * specific language governing permissions and limitations</em>
<a class="jxr_linenumber" name="18" href="#18">18</a>  <em class="jxr_comment"> * under the License.</em>
<a class="jxr_linenumber" name="19" href="#19">19</a>  <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="20" href="#20">20</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="21" href="#21">21</a>  <em class="jxr_comment"> * This software consists of voluntary contributions made by many</em>
<a class="jxr_linenumber" name="22" href="#22">22</a>  <em class="jxr_comment"> * individuals on behalf of the Apache Software Foundation.  For more</em>
<a class="jxr_linenumber" name="23" href="#23">23</a>  <em class="jxr_comment"> * information on the Apache Software Foundation, please see</em>
<a class="jxr_linenumber" name="24" href="#24">24</a>  <em class="jxr_comment"> * &lt;<a href="http://www.apache.org/&gt;." target="alexandria_uri">http://www.apache.org/&gt;.</a></em>
<a class="jxr_linenumber" name="25" href="#25">25</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="26" href="#26">26</a>  <em class="jxr_comment"> */</em>
<a class="jxr_linenumber" name="27" href="#27">27</a>  <strong class="jxr_keyword">package</strong> org.apache.http.impl.auth;
<a class="jxr_linenumber" name="28" href="#28">28</a>  
<a class="jxr_linenumber" name="29" href="#29">29</a>  <strong class="jxr_keyword">import</strong> org.junit.Assert;
<a class="jxr_linenumber" name="30" href="#30">30</a>  <strong class="jxr_keyword">import</strong> org.junit.Test;
<a class="jxr_linenumber" name="31" href="#31">31</a>  
<a class="jxr_linenumber" name="32" href="#32">32</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../org/apache/http/impl/auth/TestNTLMEngineImpl.html">TestNTLMEngineImpl</a> {
<a class="jxr_linenumber" name="33" href="#33">33</a>  
<a class="jxr_linenumber" name="34" href="#34">34</a>      @Test
<a class="jxr_linenumber" name="35" href="#35">35</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testMD4() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="36" href="#36">36</a>          checkMD4(<span class="jxr_string">""</span>, <span class="jxr_string">"31d6cfe0d16ae931b73c59d7e0c089c0"</span>);
<a class="jxr_linenumber" name="37" href="#37">37</a>          checkMD4(<span class="jxr_string">"a"</span>, <span class="jxr_string">"bde52cb31de33e46245e05fbdbd6fb24"</span>);
<a class="jxr_linenumber" name="38" href="#38">38</a>          checkMD4(<span class="jxr_string">"abc"</span>, <span class="jxr_string">"a448017aaf21d8525fc10ae87aa6729d"</span>);
<a class="jxr_linenumber" name="39" href="#39">39</a>          checkMD4(<span class="jxr_string">"message digest"</span>, <span class="jxr_string">"d9130a8164549fe818874806e1c7014b"</span>);
<a class="jxr_linenumber" name="40" href="#40">40</a>          checkMD4(<span class="jxr_string">"abcdefghijklmnopqrstuvwxyz"</span>, <span class="jxr_string">"d79e1c308aa5bbcdeea8ed63df412da9"</span>);
<a class="jxr_linenumber" name="41" href="#41">41</a>          checkMD4(<span class="jxr_string">"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789"</span>,
<a class="jxr_linenumber" name="42" href="#42">42</a>                  <span class="jxr_string">"043f8582f241db351ce627e153e7f0e4"</span>);
<a class="jxr_linenumber" name="43" href="#43">43</a>          checkMD4(
<a class="jxr_linenumber" name="44" href="#44">44</a>                  <span class="jxr_string">"12345678901234567890123456789012345678901234567890123456789012345678901234567890"</span>,
<a class="jxr_linenumber" name="45" href="#45">45</a>                  <span class="jxr_string">"e33b4ddc9c38f2199c3e7b164fcc0536"</span>);
<a class="jxr_linenumber" name="46" href="#46">46</a>      }
<a class="jxr_linenumber" name="47" href="#47">47</a>  
<a class="jxr_linenumber" name="48" href="#48">48</a>      <em class="jxr_comment">/*<em class="jxr_comment"> Test suite helper */</em></em>
<a class="jxr_linenumber" name="49" href="#49">49</a>      <strong class="jxr_keyword">static</strong> byte toNibble(<strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">char</strong> c) {
<a class="jxr_linenumber" name="50" href="#50">50</a>          <strong class="jxr_keyword">if</strong> (c &gt;= 'a' &amp;&amp; c &lt;= 'f') {
<a class="jxr_linenumber" name="51" href="#51">51</a>              <strong class="jxr_keyword">return</strong> (byte) (c - 'a' + 0x0a);
<a class="jxr_linenumber" name="52" href="#52">52</a>          }
<a class="jxr_linenumber" name="53" href="#53">53</a>          <strong class="jxr_keyword">return</strong> (byte) (c - '0');
<a class="jxr_linenumber" name="54" href="#54">54</a>      }
<a class="jxr_linenumber" name="55" href="#55">55</a>  
<a class="jxr_linenumber" name="56" href="#56">56</a>      <em class="jxr_comment">/*<em class="jxr_comment"> Test suite helper */</em></em>
<a class="jxr_linenumber" name="57" href="#57">57</a>      <strong class="jxr_keyword">static</strong> byte[] toBytes(<strong class="jxr_keyword">final</strong> String hex) {
<a class="jxr_linenumber" name="58" href="#58">58</a>          <strong class="jxr_keyword">final</strong> byte[] rval = <strong class="jxr_keyword">new</strong> byte[hex.length() / 2];
<a class="jxr_linenumber" name="59" href="#59">59</a>          <strong class="jxr_keyword">int</strong> i = 0;
<a class="jxr_linenumber" name="60" href="#60">60</a>          <strong class="jxr_keyword">while</strong> (i &lt; rval.length) {
<a class="jxr_linenumber" name="61" href="#61">61</a>              rval[i] = (byte) ((toNibble(hex.charAt(i * 2)) &lt;&lt; 4) | (toNibble(hex
<a class="jxr_linenumber" name="62" href="#62">62</a>                      .charAt(i * 2 + 1))));
<a class="jxr_linenumber" name="63" href="#63">63</a>              i++;
<a class="jxr_linenumber" name="64" href="#64">64</a>          }
<a class="jxr_linenumber" name="65" href="#65">65</a>          <strong class="jxr_keyword">return</strong> rval;
<a class="jxr_linenumber" name="66" href="#66">66</a>      }
<a class="jxr_linenumber" name="67" href="#67">67</a>  
<a class="jxr_linenumber" name="68" href="#68">68</a>      <em class="jxr_comment">/*<em class="jxr_comment"> Test suite MD4 helper */</em></em>
<a class="jxr_linenumber" name="69" href="#69">69</a>      <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> checkMD4(<strong class="jxr_keyword">final</strong> String input, <strong class="jxr_keyword">final</strong> String hexOutput) <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="70" href="#70">70</a>          NTLMEngineImpl.MD4 md4;
<a class="jxr_linenumber" name="71" href="#71">71</a>          md4 = <strong class="jxr_keyword">new</strong> NTLMEngineImpl.MD4();
<a class="jxr_linenumber" name="72" href="#72">72</a>          md4.update(input.getBytes(<span class="jxr_string">"ASCII"</span>));
<a class="jxr_linenumber" name="73" href="#73">73</a>          <strong class="jxr_keyword">final</strong> byte[] answer = md4.getOutput();
<a class="jxr_linenumber" name="74" href="#74">74</a>          <strong class="jxr_keyword">final</strong> byte[] correctAnswer = toBytes(hexOutput);
<a class="jxr_linenumber" name="75" href="#75">75</a>          <strong class="jxr_keyword">if</strong> (answer.length != correctAnswer.length) {
<a class="jxr_linenumber" name="76" href="#76">76</a>              <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> Exception(<span class="jxr_string">"Answer length disagrees for MD4('"</span> + input + <span class="jxr_string">"')"</span>);
<a class="jxr_linenumber" name="77" href="#77">77</a>          }
<a class="jxr_linenumber" name="78" href="#78">78</a>          <strong class="jxr_keyword">int</strong> i = 0;
<a class="jxr_linenumber" name="79" href="#79">79</a>          <strong class="jxr_keyword">while</strong> (i &lt; answer.length) {
<a class="jxr_linenumber" name="80" href="#80">80</a>              <strong class="jxr_keyword">if</strong> (answer[i] != correctAnswer[i]) {
<a class="jxr_linenumber" name="81" href="#81">81</a>                  <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> Exception(<span class="jxr_string">"Answer value for MD4('"</span> + input + <span class="jxr_string">"') disagrees at position "</span>
<a class="jxr_linenumber" name="82" href="#82">82</a>                          + Integer.toString(i));
<a class="jxr_linenumber" name="83" href="#83">83</a>              }
<a class="jxr_linenumber" name="84" href="#84">84</a>              i++;
<a class="jxr_linenumber" name="85" href="#85">85</a>          }
<a class="jxr_linenumber" name="86" href="#86">86</a>      }
<a class="jxr_linenumber" name="87" href="#87">87</a>  
<a class="jxr_linenumber" name="88" href="#88">88</a>      @Test
<a class="jxr_linenumber" name="89" href="#89">89</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testLMResponse() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="90" href="#90">90</a>          <strong class="jxr_keyword">final</strong> NTLMEngineImpl.CipherGen gen = <strong class="jxr_keyword">new</strong> NTLMEngineImpl.CipherGen(
<a class="jxr_linenumber" name="91" href="#91">91</a>              <strong class="jxr_keyword">null</strong>,
<a class="jxr_linenumber" name="92" href="#92">92</a>              <strong class="jxr_keyword">null</strong>,
<a class="jxr_linenumber" name="93" href="#93">93</a>              <span class="jxr_string">"SecREt01"</span>,
<a class="jxr_linenumber" name="94" href="#94">94</a>              toBytes(<span class="jxr_string">"0123456789abcdef"</span>),
<a class="jxr_linenumber" name="95" href="#95">95</a>              <strong class="jxr_keyword">null</strong>,
<a class="jxr_linenumber" name="96" href="#96">96</a>              <strong class="jxr_keyword">null</strong>,
<a class="jxr_linenumber" name="97" href="#97">97</a>              <strong class="jxr_keyword">null</strong>,
<a class="jxr_linenumber" name="98" href="#98">98</a>              <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="99" href="#99">99</a>  
<a class="jxr_linenumber" name="100" href="#100">100</a>         checkArraysMatch(toBytes(<span class="jxr_string">"c337cd5cbd44fc9782a667af6d427c6de67c20c2d3e77c56"</span>),
<a class="jxr_linenumber" name="101" href="#101">101</a>             gen.getLMResponse());
<a class="jxr_linenumber" name="102" href="#102">102</a>     }
<a class="jxr_linenumber" name="103" href="#103">103</a> 
<a class="jxr_linenumber" name="104" href="#104">104</a>     @Test
<a class="jxr_linenumber" name="105" href="#105">105</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testNTLMResponse() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="106" href="#106">106</a>         <strong class="jxr_keyword">final</strong> NTLMEngineImpl.CipherGen gen = <strong class="jxr_keyword">new</strong> NTLMEngineImpl.CipherGen(
<a class="jxr_linenumber" name="107" href="#107">107</a>             <strong class="jxr_keyword">null</strong>,
<a class="jxr_linenumber" name="108" href="#108">108</a>             <strong class="jxr_keyword">null</strong>,
<a class="jxr_linenumber" name="109" href="#109">109</a>             <span class="jxr_string">"SecREt01"</span>,
<a class="jxr_linenumber" name="110" href="#110">110</a>             toBytes(<span class="jxr_string">"0123456789abcdef"</span>),
<a class="jxr_linenumber" name="111" href="#111">111</a>             <strong class="jxr_keyword">null</strong>,
<a class="jxr_linenumber" name="112" href="#112">112</a>             <strong class="jxr_keyword">null</strong>,
<a class="jxr_linenumber" name="113" href="#113">113</a>             <strong class="jxr_keyword">null</strong>,
<a class="jxr_linenumber" name="114" href="#114">114</a>             <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="115" href="#115">115</a> 
<a class="jxr_linenumber" name="116" href="#116">116</a>         checkArraysMatch(toBytes(<span class="jxr_string">"25a98c1c31e81847466b29b2df4680f39958fb8c213a9cc6"</span>),
<a class="jxr_linenumber" name="117" href="#117">117</a>             gen.getNTLMResponse());
<a class="jxr_linenumber" name="118" href="#118">118</a>     }
<a class="jxr_linenumber" name="119" href="#119">119</a> 
<a class="jxr_linenumber" name="120" href="#120">120</a>     @Test
<a class="jxr_linenumber" name="121" href="#121">121</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testLMv2Response() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="122" href="#122">122</a>         <strong class="jxr_keyword">final</strong> NTLMEngineImpl.CipherGen gen = <strong class="jxr_keyword">new</strong> NTLMEngineImpl.CipherGen(
<a class="jxr_linenumber" name="123" href="#123">123</a>             <span class="jxr_string">"DOMAIN"</span>,
<a class="jxr_linenumber" name="124" href="#124">124</a>             <span class="jxr_string">"user"</span>,
<a class="jxr_linenumber" name="125" href="#125">125</a>             <span class="jxr_string">"SecREt01"</span>,
<a class="jxr_linenumber" name="126" href="#126">126</a>             toBytes(<span class="jxr_string">"0123456789abcdef"</span>),
<a class="jxr_linenumber" name="127" href="#127">127</a>             <strong class="jxr_keyword">null</strong>,
<a class="jxr_linenumber" name="128" href="#128">128</a>             toBytes(<span class="jxr_string">"ffffff0011223344"</span>),
<a class="jxr_linenumber" name="129" href="#129">129</a>             <strong class="jxr_keyword">null</strong>,
<a class="jxr_linenumber" name="130" href="#130">130</a>             <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="131" href="#131">131</a> 
<a class="jxr_linenumber" name="132" href="#132">132</a>         checkArraysMatch(toBytes(<span class="jxr_string">"d6e6152ea25d03b7c6ba6629c2d6aaf0ffffff0011223344"</span>),
<a class="jxr_linenumber" name="133" href="#133">133</a>             gen.getLMv2Response());
<a class="jxr_linenumber" name="134" href="#134">134</a>     }
<a class="jxr_linenumber" name="135" href="#135">135</a> 
<a class="jxr_linenumber" name="136" href="#136">136</a>     @Test
<a class="jxr_linenumber" name="137" href="#137">137</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testNTLMv2Response() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="138" href="#138">138</a>         <strong class="jxr_keyword">final</strong> NTLMEngineImpl.CipherGen gen = <strong class="jxr_keyword">new</strong> NTLMEngineImpl.CipherGen(
<a class="jxr_linenumber" name="139" href="#139">139</a>             <span class="jxr_string">"DOMAIN"</span>,
<a class="jxr_linenumber" name="140" href="#140">140</a>             <span class="jxr_string">"user"</span>,
<a class="jxr_linenumber" name="141" href="#141">141</a>             <span class="jxr_string">"SecREt01"</span>,
<a class="jxr_linenumber" name="142" href="#142">142</a>             toBytes(<span class="jxr_string">"0123456789abcdef"</span>),
<a class="jxr_linenumber" name="143" href="#143">143</a>             toBytes(<span class="jxr_string">"02000c0044004f004d00410049004e0001000c005300450052005600450052000400140064006f006d00610069006e002e0063006f006d00030022007300650072007600650072002e0064006f006d00610069006e002e0063006f006d0000000000"</span>),
<a class="jxr_linenumber" name="144" href="#144">144</a>             toBytes(<span class="jxr_string">"ffffff0011223344"</span>),
<a class="jxr_linenumber" name="145" href="#145">145</a>             <strong class="jxr_keyword">null</strong>,
<a class="jxr_linenumber" name="146" href="#146">146</a>             toBytes(<span class="jxr_string">"0090d336b734c301"</span>));
<a class="jxr_linenumber" name="147" href="#147">147</a> 
<a class="jxr_linenumber" name="148" href="#148">148</a>         checkArraysMatch(toBytes(<span class="jxr_string">"01010000000000000090d336b734c301ffffff00112233440000000002000c0044004f004d00410049004e0001000c005300450052005600450052000400140064006f006d00610069006e002e0063006f006d00030022007300650072007600650072002e0064006f006d00610069006e002e0063006f006d000000000000000000"</span>),
<a class="jxr_linenumber" name="149" href="#149">149</a>             gen.getNTLMv2Blob());
<a class="jxr_linenumber" name="150" href="#150">150</a>         checkArraysMatch(toBytes(<span class="jxr_string">"cbabbca713eb795d04c97abc01ee498301010000000000000090d336b734c301ffffff00112233440000000002000c0044004f004d00410049004e0001000c005300450052005600450052000400140064006f006d00610069006e002e0063006f006d00030022007300650072007600650072002e0064006f006d00610069006e002e0063006f006d000000000000000000"</span>),
<a class="jxr_linenumber" name="151" href="#151">151</a>             gen.getNTLMv2Response());
<a class="jxr_linenumber" name="152" href="#152">152</a>     }
<a class="jxr_linenumber" name="153" href="#153">153</a> 
<a class="jxr_linenumber" name="154" href="#154">154</a>     @Test
<a class="jxr_linenumber" name="155" href="#155">155</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testLM2SessionResponse() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="156" href="#156">156</a>         <strong class="jxr_keyword">final</strong> NTLMEngineImpl.CipherGen gen = <strong class="jxr_keyword">new</strong> NTLMEngineImpl.CipherGen(
<a class="jxr_linenumber" name="157" href="#157">157</a>             <span class="jxr_string">"DOMAIN"</span>,
<a class="jxr_linenumber" name="158" href="#158">158</a>             <span class="jxr_string">"user"</span>,
<a class="jxr_linenumber" name="159" href="#159">159</a>             <span class="jxr_string">"SecREt01"</span>,
<a class="jxr_linenumber" name="160" href="#160">160</a>             toBytes(<span class="jxr_string">"0123456789abcdef"</span>),
<a class="jxr_linenumber" name="161" href="#161">161</a>             toBytes(<span class="jxr_string">"02000c0044004f004d00410049004e0001000c005300450052005600450052000400140064006f006d00610069006e002e0063006f006d00030022007300650072007600650072002e0064006f006d00610069006e002e0063006f006d0000000000"</span>),
<a class="jxr_linenumber" name="162" href="#162">162</a>             toBytes(<span class="jxr_string">"ffffff0011223344"</span>),
<a class="jxr_linenumber" name="163" href="#163">163</a>             <strong class="jxr_keyword">null</strong>,
<a class="jxr_linenumber" name="164" href="#164">164</a>             toBytes(<span class="jxr_string">"0090d336b734c301"</span>));
<a class="jxr_linenumber" name="165" href="#165">165</a> 
<a class="jxr_linenumber" name="166" href="#166">166</a>         checkArraysMatch(toBytes(<span class="jxr_string">"ffffff001122334400000000000000000000000000000000"</span>),
<a class="jxr_linenumber" name="167" href="#167">167</a>             gen.getLM2SessionResponse());
<a class="jxr_linenumber" name="168" href="#168">168</a>     }
<a class="jxr_linenumber" name="169" href="#169">169</a> 
<a class="jxr_linenumber" name="170" href="#170">170</a>     @Test
<a class="jxr_linenumber" name="171" href="#171">171</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testNTLM2SessionResponse() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="172" href="#172">172</a>         <strong class="jxr_keyword">final</strong> NTLMEngineImpl.CipherGen gen = <strong class="jxr_keyword">new</strong> NTLMEngineImpl.CipherGen(
<a class="jxr_linenumber" name="173" href="#173">173</a>             <span class="jxr_string">"DOMAIN"</span>,
<a class="jxr_linenumber" name="174" href="#174">174</a>             <span class="jxr_string">"user"</span>,
<a class="jxr_linenumber" name="175" href="#175">175</a>             <span class="jxr_string">"SecREt01"</span>,
<a class="jxr_linenumber" name="176" href="#176">176</a>             toBytes(<span class="jxr_string">"0123456789abcdef"</span>),
<a class="jxr_linenumber" name="177" href="#177">177</a>             toBytes(<span class="jxr_string">"02000c0044004f004d00410049004e0001000c005300450052005600450052000400140064006f006d00610069006e002e0063006f006d00030022007300650072007600650072002e0064006f006d00610069006e002e0063006f006d0000000000"</span>),
<a class="jxr_linenumber" name="178" href="#178">178</a>             toBytes(<span class="jxr_string">"ffffff0011223344"</span>),
<a class="jxr_linenumber" name="179" href="#179">179</a>             <strong class="jxr_keyword">null</strong>,
<a class="jxr_linenumber" name="180" href="#180">180</a>             toBytes(<span class="jxr_string">"0090d336b734c301"</span>));
<a class="jxr_linenumber" name="181" href="#181">181</a> 
<a class="jxr_linenumber" name="182" href="#182">182</a>         checkArraysMatch(toBytes(<span class="jxr_string">"10d550832d12b2ccb79d5ad1f4eed3df82aca4c3681dd455"</span>),
<a class="jxr_linenumber" name="183" href="#183">183</a>             gen.getNTLM2SessionResponse());
<a class="jxr_linenumber" name="184" href="#184">184</a>     }
<a class="jxr_linenumber" name="185" href="#185">185</a> 
<a class="jxr_linenumber" name="186" href="#186">186</a>     @Test
<a class="jxr_linenumber" name="187" href="#187">187</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testNTLMUserSessionKey() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="188" href="#188">188</a>         <strong class="jxr_keyword">final</strong> NTLMEngineImpl.CipherGen gen = <strong class="jxr_keyword">new</strong> NTLMEngineImpl.CipherGen(
<a class="jxr_linenumber" name="189" href="#189">189</a>             <span class="jxr_string">"DOMAIN"</span>,
<a class="jxr_linenumber" name="190" href="#190">190</a>             <span class="jxr_string">"user"</span>,
<a class="jxr_linenumber" name="191" href="#191">191</a>             <span class="jxr_string">"SecREt01"</span>,
<a class="jxr_linenumber" name="192" href="#192">192</a>             toBytes(<span class="jxr_string">"0123456789abcdef"</span>),
<a class="jxr_linenumber" name="193" href="#193">193</a>             toBytes(<span class="jxr_string">"02000c0044004f004d00410049004e0001000c005300450052005600450052000400140064006f006d00610069006e002e0063006f006d00030022007300650072007600650072002e0064006f006d00610069006e002e0063006f006d0000000000"</span>),
<a class="jxr_linenumber" name="194" href="#194">194</a>             toBytes(<span class="jxr_string">"ffffff0011223344"</span>),
<a class="jxr_linenumber" name="195" href="#195">195</a>             <strong class="jxr_keyword">null</strong>,
<a class="jxr_linenumber" name="196" href="#196">196</a>             toBytes(<span class="jxr_string">"0090d336b734c301"</span>));
<a class="jxr_linenumber" name="197" href="#197">197</a> 
<a class="jxr_linenumber" name="198" href="#198">198</a>         checkArraysMatch(toBytes(<span class="jxr_string">"3f373ea8e4af954f14faa506f8eebdc4"</span>),
<a class="jxr_linenumber" name="199" href="#199">199</a>             gen.getNTLMUserSessionKey());
<a class="jxr_linenumber" name="200" href="#200">200</a>     }
<a class="jxr_linenumber" name="201" href="#201">201</a> 
<a class="jxr_linenumber" name="202" href="#202">202</a>     @Test
<a class="jxr_linenumber" name="203" href="#203">203</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testType1Message() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="204" href="#204">204</a>         <strong class="jxr_keyword">new</strong> NTLMEngineImpl().getType1Message(<span class="jxr_string">"myhost"</span>, <span class="jxr_string">"mydomain"</span>);
<a class="jxr_linenumber" name="205" href="#205">205</a>     }
<a class="jxr_linenumber" name="206" href="#206">206</a> 
<a class="jxr_linenumber" name="207" href="#207">207</a>     @Test
<a class="jxr_linenumber" name="208" href="#208">208</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testType3Message() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="209" href="#209">209</a>         <strong class="jxr_keyword">new</strong> NTLMEngineImpl().getType3Message(<span class="jxr_string">"me"</span>, <span class="jxr_string">"mypassword"</span>, <span class="jxr_string">"myhost"</span>, <span class="jxr_string">"mydomain"</span>,
<a class="jxr_linenumber" name="210" href="#210">210</a>             toBytes(<span class="jxr_string">"0001020304050607"</span>),
<a class="jxr_linenumber" name="211" href="#211">211</a>             0xffffffff,
<a class="jxr_linenumber" name="212" href="#212">212</a>             <strong class="jxr_keyword">null</strong>,<strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="213" href="#213">213</a>         <strong class="jxr_keyword">new</strong> NTLMEngineImpl().getType3Message(<span class="jxr_string">"me"</span>, <span class="jxr_string">"mypassword"</span>, <span class="jxr_string">"myhost"</span>, <span class="jxr_string">"mydomain"</span>,
<a class="jxr_linenumber" name="214" href="#214">214</a>             toBytes(<span class="jxr_string">"0001020304050607"</span>),
<a class="jxr_linenumber" name="215" href="#215">215</a>             0xffffffff,
<a class="jxr_linenumber" name="216" href="#216">216</a>             <span class="jxr_string">"mytarget"</span>,
<a class="jxr_linenumber" name="217" href="#217">217</a>             toBytes(<span class="jxr_string">"02000c0044004f004d00410049004e0001000c005300450052005600450052000400140064006f006d00610069006e002e0063006f006d00030022007300650072007600650072002e0064006f006d00610069006e002e0063006f006d0000000000"</span>));
<a class="jxr_linenumber" name="218" href="#218">218</a>     }
<a class="jxr_linenumber" name="219" href="#219">219</a> 
<a class="jxr_linenumber" name="220" href="#220">220</a>     @Test
<a class="jxr_linenumber" name="221" href="#221">221</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testRC4() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="222" href="#222">222</a>         checkArraysMatch(toBytes(<span class="jxr_string">"e37f97f2544f4d7e"</span>),
<a class="jxr_linenumber" name="223" href="#223">223</a>             NTLMEngineImpl.RC4(toBytes(<span class="jxr_string">"0a003602317a759a"</span>),
<a class="jxr_linenumber" name="224" href="#224">224</a>                 toBytes(<span class="jxr_string">"2785f595293f3e2813439d73a223810d"</span>)));
<a class="jxr_linenumber" name="225" href="#225">225</a>     }
<a class="jxr_linenumber" name="226" href="#226">226</a> 
<a class="jxr_linenumber" name="227" href="#227">227</a>     <em class="jxr_comment">/*<em class="jxr_comment"> Byte array check helper */</em></em>
<a class="jxr_linenumber" name="228" href="#228">228</a>     <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> checkArraysMatch(<strong class="jxr_keyword">final</strong> byte[] a1, <strong class="jxr_keyword">final</strong> byte[] a2)
<a class="jxr_linenumber" name="229" href="#229">229</a>         <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="230" href="#230">230</a>         Assert.assertEquals(a1.length,a2.length);
<a class="jxr_linenumber" name="231" href="#231">231</a>         <strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> i = 0; i &lt; a1.length; i++) {
<a class="jxr_linenumber" name="232" href="#232">232</a>             Assert.assertEquals(a1[i],a2[i]);
<a class="jxr_linenumber" name="233" href="#233">233</a>         }
<a class="jxr_linenumber" name="234" href="#234">234</a>     }
<a class="jxr_linenumber" name="235" href="#235">235</a> }
</pre>
<hr/><div id="footer">This page was automatically generated by <a href="http://maven.apache.org/">Maven</a></div></body>
</html>

